#pragma once

#include "CoreMinimal.h"
#include "PowerBundleViewInterface.h"
#include "CoreBaseUserWidget.h"
#include "Templates/SubclassOf.h"
#include "CorePowerBundleWidget.generated.h"

class UCorePowerWidget;
class UCoreAddonWidget;
class UUniformGridPanel;
class UCorePreConstructableList;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCorePowerBundleWidget : public UCoreBaseUserWidget, public IPowerBundleViewInterface
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear)
	TSubclassOf<UCorePowerWidget> PowerWidgetSubClass;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCorePowerWidget* Power;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreAddonWidget* Addon1;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreAddonWidget* Addon2;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UUniformGridPanel* SecondaryPowerWidgetContainer;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UUniformGridPanel* TertiaryPowerWidgetContainer;

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int32 _preConstructedPowersCount;

private:
	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UCorePreConstructableList* _secondaryPowerList;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UCorePreConstructableList* _tertiaryPowerList;

public:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void SetActiveState(bool isActive);

public:
	UCorePowerBundleWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCorePowerBundleWidget) { return 0; }
